package com.example.fuzzControll.controller.dataController;

import com.alibaba.fastjson.JSON;
import com.example.fuzzControll.domain.bo.FuzzLogTransEntity;
import com.example.fuzzControll.domain.po.KnowledgeBaseFiles;
import com.example.fuzzControll.domain.vo.AjaxResult;
import com.example.fuzzControll.exception.fileExcption.FileException;
import com.example.fuzzControll.exception.serverException.ServerException;
import com.example.fuzzControll.exception.testException.CmdException;
import com.example.fuzzControll.service.KnowledgeBaseService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

/**
 * 知识库控制器
 */
@RestController
@RequestMapping("/KnowledgeBase")
@Slf4j
public class KnowledgeBaseController {
    @Autowired
    KnowledgeBaseService knowledgeBaseService;

    /**
     * 知识库文件上传、默认文件不是复合文件
     */
    @RequestMapping(value = "/upload", method = RequestMethod.POST)
    public AjaxResult upload(@RequestParam("file") MultipartFile file) {
        try {
            knowledgeBaseService.upload(file);
            return AjaxResult.success("文件上传成功！");
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("文件上传失败！");
        }
    }

    /**
     * 知识库文件信息查看//todo有莫名其妙的错误
     */
    @RequestMapping(value = "/getallmessage", method = RequestMethod.GET)
    public AjaxResult getallmessage() {
        try {
            return AjaxResult.success(knowledgeBaseService.getAllMessage());
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return AjaxResult.error("知识库信息获取失败！");
        }
    }
    /**
     * 跟据id获取知识库数据
     */
    @RequestMapping(value = "/getById/{id}", method = RequestMethod.GET)
    public KnowledgeBaseFiles getById(@PathVariable("id") int id) {
        try {
            return knowledgeBaseService.getKnowledgeBaseFilesById(id);
        } catch (ServerException e) {
            log.error(e.getDefaultMessage());
            return null;
        }
    }
}
