package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.domain.po.KnowledgeBaseFiles;
import com.example.fuzzControll.mapper.KnowledgeBaseMapper;
import com.example.fuzzControll.service.KnowledgeBaseService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Date;
import java.util.List;

@Service("KnowledgeBaseService")
@Slf4j
public class KnowledgeBaseServiceImpl implements KnowledgeBaseService {

    @Autowired
    KnowledgeBaseMapper knowledgeBaseMapper;

    @Override
    public void upload(MultipartFile file) {
        try {
            KnowledgeBaseFiles knowledgeBaseFiles = new KnowledgeBaseFiles(file.getBytes(), new Date(), file.getOriginalFilename());
            knowledgeBaseMapper.insert(knowledgeBaseFiles);
        } catch (IOException e) {
            log.error("Creat and insert KnowledgeBaseFiles error:[{}] ", e.getMessage());
            throw new RuntimeException(e);
        }
    }

    @Override
    public List<KnowledgeBaseFiles> getAllMessage() {
        try {
            return knowledgeBaseMapper.getAllMessage();
        } catch (Exception e) {
            log.error("GetAllMessage error:[{}] ", e.getMessage());
            throw new RuntimeException(e);
        }
    }

    @Override
    public KnowledgeBaseFiles getKnowledgeBaseFilesById(int id) {
        KnowledgeBaseFiles knowledgeBaseFiles = null;
        try {
            knowledgeBaseFiles = knowledgeBaseMapper.getKnowledgeBaseFilesById(id);
        } catch (Exception e) {
            log.error("GetKnowledgeBaseFilesById error:[{}] ", e.getMessage());
            throw new RuntimeException(e);
        }
        return knowledgeBaseFiles;
    }
}
