package com.example.fuzzbackendmaster.controller;

import com.alibaba.fastjson.JSON;
import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.pojo.vo.KnowledgeBaseFiles;
import com.example.fuzzbackendmaster.service.FileDownloadService;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 知识库控制器
 */
@RestController
@RequestMapping("/KnowledgeBase")
@Slf4j
public class KnowledgeBaseController {
    @Autowired
    FileDownloadService fileDownloadService;
    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;
    /**
     * 知识库文件上传、默认文件不是复合文件
     */
    @RequestMapping(value = "/upload", method = RequestMethod.GET)
    public AjaxResult upload(@RequestPart("file") MultipartFile file) {
        return fuzzIntegrationFileApi.KnowledgeBaseUpload(file);
    }
    /**
     * 知识库文件信息查看
     */
    @RequestMapping(value = "/getallmessage", method = RequestMethod.GET)
    public AjaxResult getallmessage() {
       return fuzzIntegrationFileApi.getallmessage();
    }
    /**
     * 知识库文件下载
     */
    //todo增加批量处理功能
    @RequestMapping(value = "/download/{id}", method = RequestMethod.GET)
    public void download(@PathVariable("id") int id,HttpServletResponse response) throws IOException {
        try {
            fileDownloadService.getFile(id,response);
        } catch (Exception e) {
            e.printStackTrace();
            response.sendError(500, "Download failed!");
        }
    }
    //todo增加批量处理功能
}
